<?php

/*
=============================================================================
 : linkenso.php (frontend)  1.4
-----------------------------------------------------------------------------
 :   , mail@mithrandir.ru
-----------------------------------------------------------------------------
 :     
=============================================================================
*/

    // 
    if( !defined( 'DATALIFEENGINE' )) {
            die( "Hacking attempt!" );
    }

    /*
     *     
     */
    if(!class_exists('LinkEnso')) { class LinkEnso
    {
        /*
         *   LinkEnso -    dle_api   
         * @param $linkEnsoConfig -    
         */
        public function __construct($linkEnsoConfig)
        {
            //  DLE_API
            global $db, $config, $category;
            include ('engine/api/api.class.php');
            $this->dle_api = $dle_api;
            
            //   
            $this->config = $linkEnsoConfig;
        }


        /*
         *    LinkEnso
         */
        public function run()
        {
            //      
            $output = false;
			if($this->dle_api->dle_config['allow_cache'] && $this->dle_api->dle_config['allow_cache'] != "no")
            {
                $output = $this->dle_api->load_from_cache('linkenso_'.md5(implode('_', $this->config)));
            }
            
            //       ,   
            if($output !== false)
            {
                $this->showOutput($output);
                return;
            }
            
            //      ,   
            $wheres = array();
            
            //    ,      
            $post = $this->dle_api->load_table (PREFIX."_post", 'category', 'id = '.$this->config['postId'], false);
            
            //    DLE API -        ,    
            if(!empty($post) && !empty($post['category'])) $postCategories = array();
            
            $postCategories = explode(',', $post['category']);
            
            //          scan
            $categoriesArray = array();
            switch($this->config['scan'])
            {
                //      
                case 'same_cat':                    
                    //            
                    foreach($postCategories as $postCategory)
                    {
                        $postCategory = intval($postCategory);
                        $categoriesArray[] = $postCategory;
                        $categoriesArray = array_merge($categoriesArray, $this->getSubcategoriesArray($postCategory));
                    }
                    break;
                
                //       " "
                case 'global_cat':
                    //             
                    foreach($postCategories as $postCategory)
                    {
                        $postCategory = intval($postCategory);
                        $globalCategoryId = $this->getGlobalCategory($postCategory);
                        $categoriesArray[] = $globalCategoryId;
                        $categoriesArray = array_merge($categoriesArray, $this->getSubcategoriesArray($globalCategoryId));
                    }
                    break;
                
                default:
                    break;
            }
            
            //    
            if(count($categoriesArray) > 0)
            {
                switch($this->dle_api->dle_config['allow_multi_category'])
                {
                    //    
                    case '1':
                        $categoryWheres = array();
                        foreach($categoriesArray as $categoryId)
                        {
                            $categoryWheres[] = 'category regexp "[[:<:]]('.str_replace(',', '|', $categoryId).')[[:>:]]"';
                        }
                        $wheres[] = '('.implode(' OR ', $categoryWheres).')';
                        break;

                    //    
                    default:
                        $wheres[] = 'category IN ('.implode(',', $categoriesArray).')';
                        break;
                }               
            }
            
            //     date       
            switch($this->config['date'])
            {
                case 'new':
                    $dateWhere = 'id > '.$this->config['postId'];
                    break;
                
                default:
                    $dateWhere = 'id < '.$this->config['postId'];
                    break;
            }
            
            //     ,  
            $wheres[] = 'approve = 1';

            //      ,     
            $wheres[] = 'date < "'.date("Y-m-d H:i:s").'"';
            
            //     id
            $wheres[] = 'id != '.$this->config['postId'];
            
            //  
            $where = implode(' AND ', $wheres);
            
            //     ,      (  - ASC,   - DESC)
            $ordering = $this->config['date'] == 'new'?'ASC':'DESC';
            
            //   -   
            $postsSelect = 'id, title, metatitle, date, alt_name, category';
            $postsSelect .= $this->dle_api->dle_config['version_id'] < 9.6?', flag':''; //   dle   flag
            $posts = $this->dle_api->load_table (PREFIX."_post", $postsSelect, $where.' AND '.$dateWhere, true, 0, $this->config['links'], 'id', $ordering);

            //    DLE API -        ,    
            if(empty($posts)) $posts = array();
            
            //   -          ring   1,     
            if(count($posts) < $this->config['links'] && $this->config['ring'] == 'yes')
            {
                //   id ,   
                $posts_id_array = array();
                foreach($posts as $post)
                {
                    $posts_id_array[] = $post['id'];
                }
                
                //      
                if(!empty($posts_id_array))
                {
                    $wheres[] = 'id NOT IN('.implode(',', $posts_id_array).')';
                }
                
                //  
                $where = implode(' AND ', $wheres);
                
                //  .   
                $morePostsSelect = 'id, title, metatitle, date, alt_name, category';
                $morePostsSelect .= $this->dle_api->dle_config['version_id'] < 9.6?', flag':''; //   dle   flag
                $morePosts = $this->dle_api->load_table (PREFIX."_post", $morePostsSelect, $where, true, 0, ($this->config['links'] - count($posts)), 'id', $ordering);
                
                //    DLE API -        ,    
                if(empty($morePosts)) $morePosts = array();
            
                $posts = array_merge_recursive($posts, $morePosts);
            }
            
            //    
            if(count($posts) > 0)
            {
                $output = '<ul>';
                foreach($posts as $post)
                {
                    
                    $output .= '<li><a '.($this->config['title'] != 'empty'?'title="'.($this->config['title'] == 'name'?stripslashes($post['title']):stripslashes($post['metatitle'])).'"':'').' href="'.($this->getPostUrl($post)).'">'.($this->config['anchor'] == 'title'?stripslashes($post['metatitle']):stripslashes($post['title'])).'</a></li>';
                }
                $output .= '</ul>';
            }
            
            //   ,      
			if($this->dle_api->dle_config['allow_cache'] && $this->dle_api->dle_config['allow_cache'] != "no")
            {
                $this->dle_api->save_to_cache('linkenso_'.md5(implode('_', $this->config)), $output);
            }
            
            //   
            $this->showOutput($output);
        }
        
        
        /*
         *        
         * @param $categoryId -   
         * @return array -    
         */
        public function getSubcategoriesArray($categoryId)
        {
            //  $categoryId
            $categoryId = intval($categoryId);
            
            //    
            $subcategoriesArray = array();
            
            //   
            $subcategories = $this->dle_api->load_table (PREFIX."_category", 'id', 'parentid = '.$categoryId, true);
            if(empty($subcategories)) $subcategories = array();
            
            foreach($subcategories as $subcategory)
            {
                //     
                $subcategoriesArray[] = intval($subcategory['id']);
                
                //      
                $subcategoriesArray = array_merge($subcategoriesArray, $this->getSubcategoriesArray($subcategory['id']));
            }
            
            //   
            return $subcategoriesArray;
        }

        
        /*
         *       
         * @param $categoryId -   
         * @return int -   ""   
         */
        public function getGlobalCategory($categoryId)
        {
            //  $categoryId
            $categoryId = intval($categoryId);
            
            //       
            global $cat_info;
            
            //     ,     
            while($cat_info[$categoryId]['parentid'] > 0)
            {
                $categoryId = intval($cat_info[$categoryId]['parentid']);
            }
            
            //    
            return $categoryId;
        }


        /*
         * @param $post -     
         * @return string URL  
         */
        public function getPostUrl($post)
        {
			if($this->dle_api->dle_config['allow_alt_url'] && $this->dle_api->dle_config['allow_alt_url'] != "no")
            {
                if(
                    ($this->dle_api->dle_config['version_id'] < 9.6 && $post['flag'] && $this->dle_api->dle_config['seo_type'])
                        ||
                    ($this->dle_api->dle_config['version_id'] >= 9.6 && ($this->dle_api->dle_config['seo_type'] == 1 || $this->dle_api->dle_config['seo_type'] == 2))
                )
                {
                    if(intval($post['category']) && $this->dle_api->dle_config['seo_type'] == 2)
                    {
                        $url = $this->dle_api->dle_config['http_home_url'].get_url(intval($post['category'])).'/'.$post['id'].'-'.$post['alt_name'].'.html';
                    }
                    else
                    {
                        $url = $this->dle_api->dle_config['http_home_url'].$post['id'].'-'.$post['alt_name'].'.html';
                    }
                }
                else
                {
                    $url = $this->dle_api->dle_config['http_home_url'].date("Y/m/d/", strtotime($post['date'])).$post['alt_name'].'.html';
                }
            }
            else
            {
                $url = $this->dle_api->dle_config['http_home_url'].'index.php?newsid='.$post['id'];
            }

            return $url;
        }
        
        
        /*
         *   tpl-,        
         * @param $template -  ,   
         * @param $vars -         
         * @param $vars -         
         *
         * @return string tpl-,     $data
         */
        public function applyTemplate($template, $vars = array(), $blocks = array())
        {
            //    $template.tpl,  
            $tpl = new dle_template();
            $tpl->dir = TEMPLATE_DIR;
            $tpl->load_template($template.'.tpl');

            //   
            foreach($vars as $var => $value)
            {
                $tpl->set($var, $value);
            }

            //   
            foreach($blocks as $block => $value)
            {
                $tpl->set_block($block, $value);
            }

            //   (     ;))
            $tpl->compile($template);

            //  
            return $tpl->result[$template];
        }


        /*
         *      
         * @param $output -   
         */
        public function showOutput($output)
        {
            echo $output;
        }
    }}
    /*---End Of LinkEnso Class---*/
    
    
    //   
    $linkEnsoConfig = array(
        'postId'    => !empty($post_id)?$post_id:false,
        'links'     => !empty($links)?$links:3,
        'date'      => !empty($date)?$date:'old',
        'ring'      => !empty($ring)?$ring:'yes',
        'scan'      => !empty($scan)?$scan:'all_cat',
        'anchor'    => !empty($anchor)?$anchor:'name',
        'title'     => !empty($title)?$title:'title',
    );
    
    //          
    $linkEnso = new LinkEnso($linkEnsoConfig);
    $linkEnso->run();

?>